#!/usr/bin/env python
import os
import os.path
import logging
import socket

# simuPOP
OMP_NUM_THREADS = 2
import simuOpt
simuOpt.setOptions(numThreads=OMP_NUM_THREADS)
simuOpt.setOptions(gui = False)
#simuOpt.setOptions(optimized=False, debug = 'DBG_WARNING')

DEBUG = True

if socket.gethostname() == 'ipseg-ubuntu':
    BASE_DIR = os.path.normpath('/media/Shared/Data/sim_Ne/r2_eval-11-16-14')
        #SIMCOAL 2.1.2
        #SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/simcoal2_1_2_win/SIMCOAL2_1_2.exe")
    # 64 bit version
    SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/recompiled_SIMCOAL/SIMCOAL64.exe")
    # not compiled yet
    SIMCOAL_EXE = None
    # fastsimcoal2
    #SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/fastsimcoal2/win64/fastsimcoal21.exe")
    SIMCOAL_FORMAT = 'SIMCOAL2_64' # ['SIMCOAL2_64', 'FASTSIMCOAL2']
    
    # new PGD spider 
    PDG_SPIDER_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.exe")
    PDG_SPIDER_EXE = os.path.normpath("java -Xmx4024M -Xms512m -jar 'C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.jar'")
    
    SPID = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.4.0/arlequin_to_genepop.spid")
    PLINK_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/PLINK/plink-1.07-dos/plink.exe")
    REPORT_DIR = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/sim_data/reports")
    SCRATCH_DIR = os.path.join(BASE_DIR, 'scratch')

# Personal computer (RW)
elif os.getenv('COMPUTERNAME') == 'KELE-PC':
    BASE_DIR = os.path.normpath('D:/simNe/simDATA/aug-17')
    SIMCOAL_EXE = os.path.normpath("C:/Users/Kele/Dropbox/Projects/simulate_Ne/analysis programs/recompiled_SIMCOAL/SIMCOAL64.exe")
    SIMCOAL_FORMAT = 'SIMCOAL2_64' # ['SIMCOAL2_64', 'FASTSIMCOAL2']
    
    PDG_SPIDER_EXE = os.path.normpath("C:/Users/Kele/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.exe")
#    PDG_SPIDER_EXE = os.path.normpath("java -Xmx4024M -Xms512m -jar 'C:/Users/Kele/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.exe'")

    SPID = os.path.normpath("C:/Users/Kele/Dropbox/Programs/PGDSpider_2.0.4.0/arlequin_to_genepop.spid")
    PLINK_EXE = os.path.normpath("C:/Users/Kele/Dropbox/Projects/simulate_Ne/analysis programs/PLINK/plink-1.07-dos/plink.exe")
    REPORT_DIR = os.path.normpath("C:/Users/Kele/Dropbox/Projects/simulate_Ne/sim_data/reports")
    SCRATCH_DIR = os.path.join(BASE_DIR, 'scratch')



# Windows side of work computer
elif os.getenv('COMPUTERNAME') == 'IPSEG-PC':
    #BASE_DIR = os.path.normpath('C:/Data/sim_NE/chr_len_1')
    BASE_DIR = os.path.normpath('C:/Data/pseudo/pseudo-3-18')
        #SIMCOAL 2.1.2
        #SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/simcoal2_1_2_win/SIMCOAL2_1_2.exe")
    # 64 bit version
    SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/recompiled_SIMCOAL/SIMCOAL64.exe")
    #SIMCOAL_EXE = os.path.normpath("C:\Users\IPSEG\Desktop\Waples\Dropbox\Projects\LD_pseudoreplication\simulation\coalescent\SIMCOAL64.exe")
    # fastsimcoal2
    #SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/fastsimcoal2/win64/fastsimcoal21.exe")
    SIMCOAL_FORMAT = 'SIMCOAL2_64' # ['SIMCOAL2_64', 'FASTSIMCOAL2']
    
    # new PGD spider 
    PDG_SPIDER_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.exe")
    PDG_SPIDER_EXE = os.path.normpath('"C:/Program Files/Java/jre7/bin/java.exe" -Xmx4024M -jar "C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.jar"')
    
    SPID = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.4.0/arlequin_to_genepop.spid")
    PLINK_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/PLINK/plink-1.07-dos/plink.exe")
    
    #REPORT_DIR = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/sim_data/reports")
    REPORT_DIR = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/LD_pseudoreplication/reports")
    SCRATCH_DIR = os.path.join(BASE_DIR, 'scratch')

# Dell laptop
elif os.getenv('COMPUTERNAME') == 'KELE':
    BASE_DIR = os.path.normpath('C:/Data/sim_Ne/bias_eval_9-11-15')
        #SIMCOAL 2.1.2
        #SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/simcoal2_1_2_win/SIMCOAL2_1_2.exe")
    # 64 bit version
    SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/recompiled_SIMCOAL/SIMCOAL64.exe")
    # fastsimcoal2
    #SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/fastsimcoal2/win64/fastsimcoal21.exe")
    SIMCOAL_FORMAT = 'SIMCOAL2_64' # ['SIMCOAL2_64', 'FASTSIMCOAL2']
    
    # new PGD spider 
    PDG_SPIDER_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.exe")
    PDG_SPIDER_EXE = os.path.normpath("java -Xmx4024M -Xms512m -jar 'C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.5.1/PGDSpider2-cli.jar'")
    
    SPID = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Programs/PGDSpider_2.0.4.0/arlequin_to_genepop.spid")
    PLINK_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/PLINK/plink-1.07-dos/plink.exe")
    REPORT_DIR = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/sim_data/reports")
    SCRATCH_DIR = os.path.join(BASE_DIR, 'scratch')

	
	
	
elif os.getenv('COMPUTERNAME') == 'WESLARSON-PC':
    BASE_DIR = os.path.normpath('C:/Users/Ryan/Documents/Sim_Ne/batch_01')
    #SIMCOAL_EXE = os.path.normpath("C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/analysis programs/simcoal2_1_2_win/SIMCOAL2_1_2.exe")
    # new 64 bit version
    SIMCOAL_EXE = os.path.normpath("C:/Users/Ryan/Dropbox/Projects/simulate_Ne/analysis programs/recompiled_SIMCOAL/SIMCOAL64.exe")
    PDG_SPIDER_EXE = os.path.normpath("C:/Users/Ryan/Dropbox/Programs/PGDSpider_2.0.4.0/PGDSpider2-cli.exe")
    SPID = os.path.normpath("C:/Users/Ryan/Dropbox/Programs/PGDSpider_2.0.4.0/arlequin_to_genepop.spid")
    PLINK_EXE = os.path.normpath("C:/Users/Ryan/Dropbox/Projects/simulate_Ne/analysis programs/PLINK/plink-1.07-dos/plink.exe")
    REPORT_DIR = os.path.normpath("C:/Users/Ryan/Dropbox/Projects/simulate_Ne/sim_data/reports")
    SCRATCH_DIR = os.path.join(BASE_DIR, 'scratch')


