#!/usr/bin/env python
import os.path
import glob
import subprocess
import shlex
from PARAMS import DEBUG

import logging
import log_config
PGD_spider_log = logging.getLogger('PGD_spider')

def pgd_genepop_to_ped(spid,
			pgd_exe,
			target_dir, 
			output_dir, 
			target_ext
			):
	to_convert = glob.glob("{}/*{}".format(target_dir, target_ext))
	for each_file in to_convert:
		rootname = os.path.splitext(os.path.basename(each_file))[0]
		with open(spid, 'r') as INFILE:
			lines = INFILE.read().split("\r")
		with open(spid, 'w') as OUTFILE:
			for line in lines:
				if line.startswith("PED_WRITER_MAP_FILE_QUESTION="):
					#OUTFILE.write("PED_WRITER_MAP_FILE_QUESTION=" + r"C:\\DATA\\simuPOP\\burrows_test\\ped\\" + rootname + ".map" + "\r")
					map_filename = os.path.join(output_dir, rootname + ".map")
					# hack to make path work
					map_filename = map_filename.replace("\\", "\\\\")
					OUTFILE.write(r"PED_WRITER_MAP_FILE_QUESTION=" + map_filename + "\r")
				else:
					OUTFILE.write(line.strip() + "\r")
		to_exec = "{} -inputfile {} -outputfile {} -spid {}".format(pgd_exe, each_file, os.path.join(output_dir, rootname + ".ped"), spid)
		#print("\n"+to_exec +"\n")
		PGD_spider_log.debug(to_exec)		
		subprocess.call(to_exec, shell = True)
		

def pgd_arlequin_to_genepop(spid, pgd_exe, in_file, output_dir):
		#if DEBUG: print('Start PGD to arlequin:\n .spid file: {}\n in_file: {}\n output_dir: {}'.format(spid, in_file, output_dir)) 
		PGD_spider_log.debug('Start PGD to arlequin: .spid file: {} in_file: {} output_dir: {}'.format(spid, in_file, output_dir)) 
		rootname = os.path.splitext(os.path.basename(in_file))[0]
		#if DEBUG: print ("rootname: {}".format(rootname))
		PGD_spider_log.debug("rootname: {}".format(rootname))
		to_exec = '{} -inputfile "{}" -outputfile "{}" -spid "{}"'.format(pgd_exe, in_file, os.path.join(output_dir, rootname + ".genpop0"), spid)
		#to_exec = '{} -inputfile {} -outputfile {} -spid {}'.format(pgd_exe, in_file, os.path.join(output_dir, rootname + ".genpop0"), spid)
		PGD_spider_log.debug("PGD command line: {} ".format(to_exec))
		subprocess.call(shlex.split(to_exec))
		return(os.path.join(output_dir, rootname + ".genpop0"))
	
