import numpy
import matplotlib.pyplot as plt

from Results_class_WORKING import Sim_Results
from chi2_distribution import generate_bins, find_chi2_of_r2

DATA_DIR = "D:/simNe/simDATA/mar-10a"

myres = Sim_Results(DATA_DIR, "pop_200+loci_400+chr_4+cM_100+cMunit_1000+ascern_01+genome_1-1+samp_100+gen_10+simupop_0+simcoal_0+samp_1")

myres.weighted_chi2_correction()

myres.chi2_correction(expected_count_threshold = 1)

myres.weighted_chi2_correction()

my_bins = generate_bins(interval = 0.01)
exp_intervals, exp_counts = find_chi2_of_r2(
    r2 = myres.r2_of_subset['all'], num_obs= myres.pairs_of_subset['all'], bins = my_bins
    )
# make sure this is inline with the intervals above
obs_counts, obs_intervals = plt.hist(myres.r2_plink, log = True, bins = numpy.arange(0, 1.01, 0.01))[0:2] 

exp_intervals[exp_intervals < 1] + 0.005


plt.plot(exp_intervals[exp_intervals < 1] + 0.005, obs_counts / exp_counts[exp_intervals <= 1])
plt.semilogy()


numpy.mean(obs_counts * (obs_intervals[obs_intervals < 1] +.005))


plt.semilogx()
plt.xlim(0, .5)
plt.ylim(-1, 1000000)

from chi2_distribution import generate_bins, find_chi2_of_r2

my_bins = generate_bins()
intervals, counts =  find_chi2_of_r2(r2 = myres.r2_of_subset['all'], num_obs= myres.pairs_of_subset['all'], bins = my_bins)

plt.plot(exp_intervals, exp_counts, color = 'green', linewidth= 4.0, alpha = .5, label = "ChiSq, overall mean r2")	
plt.hist(myres.r2_plink, log = True, bins = numpy.arange(0, 1.01, 0.01), alpha = .5, color = 'blue', label = "Simulated Data")
plt.xlim(-.04, 1.04)
plt.ylim(ymin=.01)
# plt.semilogy() # needing if the hist doesn't log scale

# Now try to interatively apply a cutoff of 1 expected count
# idx = leftmost bin where expected count falls below 1
idx = numpy.nonzero(counts < 1)[0][0]
threshold_r2 = intervals[idx]
numpy.mean(myres.subset_by_r2_max(r2_vector = myres.r2_plink, r2_max = threshold_r2))
numpy.mean(myres.r2_plink)








####
intervals < intervals[idx]
counts



from scipy.stats import chi2
interval = .01
max = 10
left_intervals = numpy.arange(0, max, interval)
right_intervals = numpy.arange(interval, max + interval, interval)	
at_or_above_one = right_intervals >= 1.0
at_one = right_intervals == 1.0

mean_r2_cumulative_density = None
mean_r2 = myres.r2_of_subset['c==0.5']
count_loci = numpy.sum(myres.subset_loci_by_c['c==0.5']) # misnamed
scaled_chi2_dist_frozen = chi2(1, scale = mean_r2)
scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
scaled_interval_density = scaled_right_cdf - scaled_left_cdf
scaled_interval_density *= count_loci
#print(mean_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
if mean_r2_cumulative_density is None:
	mean_r2_cumulative_density = scaled_interval_density
else:
	mean_r2_cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(mean_r2_cumulative_density[at_or_above_one])
mean_r2_cumulative_density[at_or_above_one] = 0
mean_r2_cumulative_density[at_one] = density_above_one

plt.plot((right_intervals + left_intervals)/2., mean_r2_cumulative_density, color = 'yellow', linewidth= 4.0, alpha = 1, label = "ChiSq, overall mean r2")	
plt.hist(myres.r2_plink, log = True, bins = numpy.arange(0, 1.01, 0.01), alpha = .5, color = 'blue', label = "Simulated Data")
plt.xlim(-.04, 1.04)
plt.ylim(ymin=.01)

obs_data = plt.hist(myres.r2_plink, log = True, bins = numpy.arange(0, 1.01, 0.01))
plt.plot(obs_data[1][1:], numpy.log(obs_data[0]/mean_r2_cumulative_density))

# moving from the left find the value in mean_r2_cumulative_density that first goes below x
idx = numpy.nonzero(mean_r2_cumulative_density < 0.1)[0][0]
((right_intervals + left_intervals)/2)[idx]
# returns a cutoff value in r2 - lets incorporate this into the results summary#
# this could aslo be applied interatively!!!

# next option is to scale by comparing the full distributions, not just the threshold value.

############################################

cumulative_density = None
for each_r2, each_r2_count in count_of_exp_r2.items():
	scaled_chi2_dist_frozen = chi2(1, scale = each_r2)
	scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
	scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
	scaled_interval_density = scaled_right_cdf - scaled_left_cdf
	scaled_interval_density *= each_r2_count
	#print(each_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
	if cumulative_density is None:
		cumulative_density = scaled_interval_density
	else:
		cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(cumulative_density[at_or_above_one])
cumulative_density[at_or_above_one] = 0
cumulative_density[at_one] = density_above_one














# examine the best values for these two correction methods
myres.find_best_r2_fraction()
myres.find_best_r2_max()


def find_nearest(array,value):
    idx = numpy.abs(numpy.array(array)-value).argmin()
    return idx

numpy.mean(myres.subset_by_r2_max(myres.r2_plink, 0.5))
numpy.mean(myres.r2_plink)
myres.expected_r2_unlinked


corrected_mean = []
x_axis = []
for xx in numpy.arange(0, 1, .01):
    corrected_mean.append(numpy.mean(myres.subset_by_r2_max(myres.r2_plink, xx)))
    x_axis.append(xx)
plot(x_axis, corrected_mean)

# find the place on the line nearest the unbiased value
idx = find_nearest(corrected_mean, myres.expected_r2_unlinked)
plot(x_axis[idx], myres.expected_r2_unlinked, 'bo')

corrected_mean = []
x_axis = []
for xx in numpy.arange(0.01, 1, .001):
    corrected_mean.append(numpy.mean(myres.subset_by_r2_fraction(myres.r2_plink, xx)))
    x_axis.append(xx)
plot(x_axis, corrected_mean)
idx = find_nearest(corrected_mean, myres.expected_r2_unlinked)
plot(x_axis[idx], myres.expected_r2_unlinked, 'bo')
title(str(x_axis[idx]))



myres.plot_c_obs_r2()

