import simuPOP
import os.path
import logging
from random import shuffle

controlled_matting_log = logging.getLogger('controlled_mating')


def parent_shuffle(par):
    males = [x[0] for x in par]
    females = [x[1] for x in par]
    shuffle(males)
    shuffle(females)
    return(zip(males, females))

def fixedChooser(pop):
    popSize = pop.popSize()
    #print('Entered fixedChooser')
    controlled_matting_log.info('Entered fixedChooser')
    # identify males and females    
    male_dict = dict()
    female_dict = dict()
    for indx, ind in enumerate(pop.individuals()):
        if ind.sex() == simuPOP.MALE:
            male_dict[indx] = ind
        elif ind.sex() == simuPOP.FEMALE:
            female_dict[indx] = ind  
    #print("Populated dictionaries")
    #print('males_dict', male_dict.keys())
    #print('females_dict', female_dict.keys())  
    #print("parent males: {}, parent females: {}".format(len(male_dict), len(female_dict) ))
    file_parents = list()
    pick_filename = "C:/Users/IPSEG/Desktop/Waples/Dropbox/Projects/simulate_Ne/sim_data/parent_pick/{}_{}.pick".format(int(popSize), int(popSize))
    #print(pick_filename)
    #print(os.path.isfile(pick_filename))
    # file represents the 0-popsize/2 males/females in each dict
    with open(pick_filename) as INFILE:
        for cnt, line in enumerate(INFILE):
            parents_from_file = [int(xx) for xx in line.strip().split()]
            #print (cnt)
            file_parents.append(parents_from_file)

    # randomize these parent pairs    
    file_parents = parent_shuffle(file_parents)
    
    
    #print("File parents", file_parents)
    
    #for cnt, file_parent_pair in enumerate(file_parents):
    #    print ('offspring: {}, file male: {}, file female: {}'.format(cnt, file_parent_pair[0], file_parent_pair[1] ))
    #    pop_male = male_dict.keys()[file_parent_pair[0]]
    #    pop_female = female_dict.keys()[file_parent_pair[1]]
    #    print('offspring: {}, pop male: {}, pop female: {}'.format(cnt, pop_male, pop_female))
    #    print("\n")
    #
    #print('zero!!')
    
    for cnt, file_parent_pair in enumerate(file_parents):
        #print ('offspring: {}, file male: {}, file female: {}'.format(cnt, file_parent_pair[0], file_parent_pair[1] ))
        pop_male = male_dict.keys()[file_parent_pair[0]]
        pop_female = female_dict.keys()[file_parent_pair[1]]
        #print('offspring: {}, pop male: {}, pop female: {}'.format(cnt, pop_male, pop_female))
        if pop_male in male_dict and pop_female in female_dict: 
            #print ('Found!')
            yield pop_male, pop_female
        else:
            #print('Not Found')
            yield(None)



my_pop = simuPOP.Population(200)
simuPOP.initSex(my_pop, maleProp = .5)
print([x for x in fixedChooser(my_pop)])

       
#fixed_fam_files = glob.glob("C:/Users/Kele/Dropbox/Projects/simulate_Ne/sim_data/parent_pick/*.pick")
#parents_of_N = dict()
#for fixed_file in fixed_fam_files:
#    basename = os.path.basename(fixed_file)
#    N = int(basename.split("_")[0])
#    realized_Ne = basename.split(".")[0].split("_")[1]
#    parents = list()
#    with open (fixed_file, 'r') as INFILE:
#        for line in INFILE:
#            picked_parents = [int(xx) for xx in line.strip().split()]
#            parents.append(picked_parents)
#    parents_of_N[N] = parents, realized_Ne