import simuPOP
import random

def fixedChooser(pop):
    popSize = pop.popSize()
    # identify males and females    
    male_dict = dict()
    female_dict = dict()
    for indx, ind in enumerate(pop.individuals()):
        if ind.sex() == simuPOP.MALE:
            male_dict[indx] = ind
        elif ind.sex() == simuPOP.FEMALE:
            female_dict[indx] = ind  
    parents = list()
    print("len(male_dict): {}, len(female_dict): {}".format(len(male_dict), len(female_dict) ))
    for ii in range (popSize):
        parents.append([random.randint(0, 99), random.randint(0, 99)])
        #parents.append([random.randint(0, len(male_dict) -1), random.randint(0, len(male_dict) -1)])
    print(parents)
    while True:
        for cnt, parents in enumerate(parents):
            picked_male = male_dict.keys()[parents[0]]
            picked_female = female_dict.keys()[parents[1]]
            print('{} picked male, female: {}, {}'.format(cnt, picked_male, picked_female))
            if picked_male in male_dict and picked_female in female_dict: 
                print ('Found!')
                yield picked_male, picked_female
            else:
                print('Not Found')
                yield(None)
    
    
# Chosen Parents
my_pop= simuPOP.Population(
    size = 200, 
    loci= [100],
    )
my_pop.setGenotype([1])
simuPOP.initSex(my_pop, sex=[simuPOP.MALE, simuPOP.FEMALE])
my_pop.evolve(
    initOps = [#simuPOP.InitSex(maleProp = .5)
                #sex=[simuPOP.MALE, simuPOP.FEMALE]
                ],
    matingScheme = simuPOP.HomoMating(
        chooser = simuPOP.PyParentsChooser(fixedChooser),
	generator = simuPOP.OffspringGenerator(ops=simuPOP.Recombinator(intensity = 1), 
	   sexMode = (simuPOP.GLOBAL_SEQUENCE_OF_SEX, simuPOP.MALE, simuPOP.FEMALE)
	   ),
        subPopSize = my_pop.popSize()
        ),
    preOps = [], 
    postOps = [simuPOP.PyEval(r'"Generation: {}\n".format(gen)')],
    gen = 50
)


# Random Parents
my_pop.evolve(
    initOps = [simuPOP.InitSex()],
    matingScheme = simuPOP.RandomMating(
        #chooser = simuPOP.PyParentsChooser(fixedChooser),
	#generator = simuPOP.OffspringGenerator(ops=simuPOP.Recombinator(intensity = 1)),
        subPopSize = my_pop.popSize()
	# Ensures sex ratio = 1
	# sexMode = (simuPOP.GLOBAL_SEQUENCE_OF_SEX, simuPOP.MALE, simuPOP.FEMALE)]
    ),
    preOps = [], 
    postOps = [],
    gen = 50
)

