#from External_Data_class import *

%run -i "C:/Users/waplesry/Dropbox/Projects/simulate_Ne/scripts/python/External_Data_class.py"

kkogr = External_Data(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\wak_KKOGR_markers_on_map_genepop_for_ldne.gen")
kkokt = External_Data(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\wak_KKOKT_markers_on_map_genepop_for_ldne.gen")
ktubu = External_Data(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\wak_KTUBU_markers_on_map_genepop_for_ldne.gen")
kanvi = External_Data(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\wak_KANVI_markers_on_map_genepop_for_ldne.gen")
kbig = External_Data(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\wak_KBIG_markers_on_map_genepop_for_ldne.gen")

kkogr.filter_missing()
kkokt.filter_missing()
ktubu.filter_missing()
kanvi.filter_missing()
kbig.filter_missing()

kkogr.filter_MAF()
kkokt.filter_MAF()
ktubu.filter_MAF()
kanvi.filter_MAF()
kbig.filter_MAF()

kkogr.load_map(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\linkage_map_wak.txt")
kkokt.load_map(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\linkage_map_wak.txt")
ktubu.load_map(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\linkage_map_wak.txt")
kanvi.load_map(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\linkage_map_wak.txt")
kbig.load_map(r"C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data\linkage_map_wak.txt")

kkogr.sample_size_matrix()
kkokt.sample_size_matrix()
ktubu.sample_size_matrix()
kanvi.sample_size_matrix()
kbig.sample_size_matrix()

kkogr.map_to_c_matrix(filename = os.path.join(kkogr.path, kkogr.basename + ".cmat.gz"))
kkokt.map_to_c_matrix(filename = os.path.join(kkokt.path, kkokt.basename + ".cmat.gz"))
ktubu.map_to_c_matrix(filename = os.path.join(ktubu.path, ktubu.basename + ".cmat.gz"))
kanvi.map_to_c_matrix(filename = os.path.join(kanvi.path, kanvi.basename + ".cmat.gz"))
kbig.map_to_c_matrix(filename = os.path.join(kbig.path, kbig.basename + ".cmat.gz"))

kkogr.expected_r2_WH(2000, S = kkogr.S_mat)
kkogr.expected_r2_SF(2000, S = kkogr.S_mat)
kkogr.expected_r2_lower()

kkokt.expected_r2_WH(2000, S = kkokt.S_mat)
kkokt.expected_r2_SF(2000, S = kkokt.S_mat)
kkokt.expected_r2_lower()

ktubu.expected_r2_WH(Ne = 2000, S = ktubu.S_mat)
ktubu.expected_r2_SF(Ne = 2000, S = ktubu.S_mat)
ktubu.expected_r2_lower()

kanvi.expected_r2_WH(2000, S = kanvi.S_mat)
kanvi.expected_r2_SF(2000, S = kanvi.S_mat)
kanvi.expected_r2_lower()

kbig.expected_r2_WH(2000, S = kbig.S_mat)
kbig.expected_r2_SF(2000, S = kbig.S_mat)
kbig.expected_r2_lower()

numpy.savetxt(X = kkogr.r2_lower, fname = os.path.join(kkogr.path, kkogr.basename + ".lower_r2_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = kkokt.r2_lower, fname = os.path.join(kkokt.path, kkokt.basename + ".lower_r2_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = ktubu.r2_lower, fname = os.path.join(ktubu.path, ktubu.basename + ".lower_r2_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = kanvi.r2_lower, fname = os.path.join(kanvi.path, kanvi.basename + ".lower_r2_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = kbig.r2_lower, fname = os.path.join(kbig.path, kbig.basename + ".lower_r2_mat.gz"), delimiter = "\t", fmt = '%1.6f')


numpy.savetxt(X = kkogr.c_matrix, fname = os.path.join(kkogr.path, kkogr.basename + ".c_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = kkokt.c_matrix, fname = os.path.join(kkokt.path, kkokt.basename + ".c_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = ktubu.c_matrix, fname = os.path.join(ktubu.path, ktubu.basename + ".c_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = kanvi.c_matrix, fname = os.path.join(kanvi.path, kanvi.basename + ".c_mat.gz"), delimiter = "\t", fmt = '%1.6f')
numpy.savetxt(X = kbig.c_matrix, fname = os.path.join(kbig.path, kbig.basename + ".c_mat.gz"), delimiter = "\t", fmt = '%1.6f')

kkogr.export_map_ped()
kkokt.export_map_ped()
ktubu.export_map_ped()
kanvi.export_map_ped()
kbig.export_map_ped()

kkogr.set_folded()
kkokt.set_folded()
ktubu.set_folded()
kanvi.set_folded()
kbig.set_folded()


batch_plink_r2(os.path.join(PLINK_DIR, "*.ped"), maf = PLINK_MAF, plink_exe = PLINK_EXE)

sr_KKOGR = Sim_Results(r'C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data', r'wak_KKOGR_markers_on_map_genepop_for_ldne', sim = False)
sr_KKOKT = Sim_Results(r'C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data', r'wak_KKOKT_markers_on_map_genepop_for_ldne', sim = False)
sr_KTUBU = Sim_Results(r'C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data', r'wak_KTUBU_markers_on_map_genepop_for_ldne', sim = False)
sr_KANVI = Sim_Results(r'C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data', r'wak_KANVI_markers_on_map_genepop_for_ldne', sim = False)
sr_KBIG = Sim_Results(r'C:\Users\waplesry\Dropbox\Projects\simulate_Ne\real_data', r'wak_KBIG_markers_on_map_genepop_for_ldne', sim = False)



# pgd_genepop_to_ped(spid = SPID,
					# target_dir = BASE_DIR, 
					# output_dir = PLINK_DIR, 
					# target_ext = ".gen2",
					# pgd_exe = PDG_SPIDER_EXE)
					
# Rename MAP files
# rename_MAP_files(os.path.join(PLINK_DIR, "*.map.txt"))

# Run Plink to get R2 matrixes 


