


# a distribution of..
#binomial distributions
#length == 1/2 * N
#mean == 2
#sum == length *2 
#variance *exactly* equal to binomial variance

#sum K_subI^2 = 2N-1 (??)
import scipy
import random
for N in [50, 100, 200, 400, 800, 1600, 3200, 6400]:
	females = numpy.arange(0, N/2)
	males = numpy.arange(N/2, N)
	to_plot_x = list()
	to_plot_y = list()
	for ii in range(0, 1000): # try 100 times
		female_parents = list()
		male_parents = list()
		for xx in range(0, N): # for each offspring
			# pick parents
			F = random.randrange(0, N/2)
			M = random.randrange(0, N/2)
			female_parents.append(females[F])
			male_parents.append(males[M])
		female_family_sizes = list()
		male_family_sizes = list()
		for xx in females:
			female_family_sizes.append(female_parents.count(xx))
		for xx in males:
			male_family_sizes.append(male_parents.count(xx))
		family_sizes = numpy.array(female_family_sizes + male_family_sizes)
		variance = numpy.var(family_sizes)
		Ne = ((2. * N) - 1) / ((numpy.sum(numpy.power(family_sizes, 2))/(2. * N)) - 1)
		#print(variance, Ne)
		to_plot_x.append(ii)
		to_plot_y.append(Ne/N)
	plot(to_plot_x, sorted(to_plot_y), label = str(N))	
xlim(-10, 1010)
title("Ne/N ratio over 1000 trials\n Eight different N values")


#PyParentsChooser(generator)
import numpy
import random
import scipy.stats
# approach:
	# at the start of simulation setup, attempt to generate a tolerable vector of parent contributions for each simulated N.
		# if successful, store each as a list, to be supplied as a generator as needed to simuPOP.
		# if NOT successful, abort simulations, or perhaps increase tolerance and repeat as needed.. 
def return_parent_choose_generator(N, target_Ne, tolerance = 1, iter = 1000):
	"""Returns a generator for use within simuPOP as a PyParentsChooser(generator)
	"""
	if not N%2==0:  #Ensure n is even, so that males and females can be present in equal numbers.
		print("N should be even.")
		return(None)
	realized_Ne_list= list()
	females = numpy.arange(0, N/2)
	males = numpy.arange(0, N/2)
	for ii in range(0, iter): # try iter number of times
		female_parents = list()
		male_parents = list()
		for xx in range(0, N):		# for each offspring
			# pick parents
			F_parent = random.randrange(0, N/2)
			M_parent = random.randrange(0, N/2)
			female_parents.append(females[F_parent])
			male_parents.append(males[M_parent])
		female_family_sizes = list()
		male_family_sizes = list()
		for xx in females:
			female_family_sizes.append(female_parents.count(xx))
		for xx in males:
			male_family_sizes.append(male_parents.count(xx))
		family_sizes = numpy.array(female_family_sizes + male_family_sizes)
		variance = numpy.var(family_sizes)
		Ne = ((2. * N) - 1) / ((numpy.sum(numpy.power(family_sizes, 2))/(2. * N)) - 1)
		print("\nIter: {}".format(ii))
		print("N = {}, target Ne = {}, realized Ne = {}, variance = {}".format(N, target_Ne, Ne, variance))
		if numpy.abs(target_Ne - Ne) < tolerance:
		  return ([(int(xx[0]), int(xx[1]))  for xx in zip(female_parents, male_parents)], Ne)
		else:
			realized_Ne_list.append(Ne)
			print("Harmonic Mean of realized Ne so far = {}".format(scipy.stats.hmean(realized_Ne_list)))
			vlines(ii, ymin = min([N, Ne]), ymax = max([N, Ne]), color = 'red', alpha = .5)
			scatter(ii, Ne, color = "blue")
			scatter(ii, N, color = 'gray')
			draw()
			pause(0.01)
	return(None) # Need something better to do here if we fail to find a tolerable answer.

import cPickle as pickle
import os.path

parent_vectors = dict()
for xx in [50, 100, 200, 400, 800, 1600, 3200, 6400]:
    figure(xx)
    parent_vectors[xx] = return_parent_choose_generator(xx, xx, .1)
    #savefig()

for key, value in parent_vectors.items():
    with open(os.path.join("C:\Users\Kele\Dropbox\Projects\simulate_Ne\sim_data\parent_pick", "{}_{}.pick".format(key, int(value[1]))), 'w') as OUTFILE:
        for parents in value[0]:
            OUTFILE.write("{}\t{}\n".format(parents[0], parents[1]))
            



