from Results_class import Sim_Results
SR1 = Sim_Results(r'C:\DATA\simuPOP\batch_24', "pop_200+loci_1000+chr_10+cM_100+cMunit_1000+ascern_04+genome_0+samp_100+gen_10+simupop_9+simcoal_6")
SR2 = Sim_Results(r'C:\DATA\simuPOP\batch_24', "pop_800+loci_1000+chr_10+cM_100+cMunit_1000+ascern_04+genome_0+samp_100+gen_10+simupop_9+simcoal_6")
	
import collections 	
count_of_exp_r2 = collections.defaultdict(int)
for each_r2 in numpy.round(SR1.expected_r2, 6):
	count_of_exp_r2[each_r2] +=1 

from scipy.stats import chi2
interval = .01
max = 10
left_intervals = np.arange(0, max, interval)
right_intervals = np.arange(interval, max + interval, interval)	
at_or_above_one = right_intervals >= 1.0
at_one = right_intervals == 1.0
cumulative_density = None
for each_r2, each_r2_count in count_of_exp_r2.items():
	#print(each_r2, each_r2_count)
	scaled_chi2_dist_frozen = chi2(1, scale = each_r2)
	scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
	scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
	scaled_interval_density = scaled_right_cdf - scaled_left_cdf
	scaled_interval_density *= each_r2_count
	#print(each_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
	if cumulative_density is None:
		cumulative_density = scaled_interval_density
	else:
		cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(cumulative_density[at_or_above_one])
cumulative_density[at_or_above_one] = 0
cumulative_density[at_one] = density_above_one

#As if each loci had the mean r2 value.
mean_r2_cumulative_density = None
mean_r2 = numpy.mean(SR1.r2_of_subset['all'])
count_loci = len(SR1.expected_r2)
scaled_chi2_dist_frozen = chi2(1, scale = mean_r2)
scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
scaled_interval_density = scaled_right_cdf - scaled_left_cdf
scaled_interval_density *= count_loci
#print(mean_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
if mean_r2_cumulative_density is None:
	mean_r2_cumulative_density = scaled_interval_density
else:
	mean_r2_cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(mean_r2_cumulative_density[at_or_above_one])
mean_r2_cumulative_density[at_or_above_one] = 0
mean_r2_cumulative_density[at_one] = density_above_one

unlinked_r2_cumulative_density = None
unlinked_r2 = numpy.mean(SR1.r2_of_subset['c==0.5'])
count_loci = len(SR1.expected_r2)
scaled_chi2_dist_frozen = chi2(1, scale = unlinked_r2)
scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
scaled_interval_density = scaled_right_cdf - scaled_left_cdf
scaled_interval_density *= count_loci
#print(unlinked_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
if unlinked_r2_cumulative_density is None:
	unlinked_r2_cumulative_density = scaled_interval_density
else:
	unlinked_r2_cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(unlinked_r2_cumulative_density[at_or_above_one])
unlinked_r2_cumulative_density[at_or_above_one] = 0
unlinked_r2_cumulative_density[at_one] = density_above_one


figure(1)
plot((right_intervals + left_intervals)/2., cumulative_density, color = 'red', linewidth= 4.0, alpha = 1, label = "Expected r2")	
plot((right_intervals + left_intervals)/2., mean_r2_cumulative_density, color = 'yellow', linewidth= 4.0, alpha = 1, label = "ChiSq, overall mean r2")	
plot((right_intervals + left_intervals)/2., unlinked_r2_cumulative_density, color = 'purple', linewidth= 4.0, alpha = 1, label = "Unlinked ChiSq ")
hist(SR1.r2_plink, log = True, bins = numpy.arange(0, 1.01, 0.01), alpha = .5, color = 'blue', label = "Simulated Data")
xlim(-.04, 1.04)
ylim(ymin=.1)
ylabel("Count")
xlabel("r2")
legend(loc = "top left")
title("Effective size = 200, 10 chromosomes of 100 loci each")
	
	
	
import collections 	
count_of_exp_r2 = collections.defaultdict(int)
for each_r2 in numpy.round(SR2.expected_r2, 6):
	count_of_exp_r2[each_r2] +=1 

from scipy.stats import chi2
interval = .01
max = 10
left_intervals = np.arange(0, max, interval)
right_intervals = np.arange(interval, max + interval, interval)	
at_or_above_one = right_intervals >= 1.0
at_one = right_intervals == 1.0
cumulative_density = None
for each_r2, each_r2_count in count_of_exp_r2.items():
	#print(each_r2, each_r2_count)
	scaled_chi2_dist_frozen = chi2(1, scale = each_r2)
	scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
	scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
	scaled_interval_density = scaled_right_cdf - scaled_left_cdf
	scaled_interval_density *= each_r2_count
	#print(each_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
	if cumulative_density is None:
		cumulative_density = scaled_interval_density
	else:
		cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(cumulative_density[at_or_above_one])
cumulative_density[at_or_above_one] = 0
cumulative_density[at_one] = density_above_one

#As if each loci had the mean r2 value.
mean_r2_cumulative_density = None
mean_r2 = numpy.mean(SR2.r2_of_subset['all'])
count_loci = len(SR2.expected_r2)
scaled_chi2_dist_frozen = chi2(1, scale = mean_r2)
scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
scaled_interval_density = scaled_right_cdf - scaled_left_cdf
scaled_interval_density *= count_loci
#print(mean_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
if mean_r2_cumulative_density is None:
	mean_r2_cumulative_density = scaled_interval_density
else:
	mean_r2_cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(mean_r2_cumulative_density[at_or_above_one])
mean_r2_cumulative_density[at_or_above_one] = 0
mean_r2_cumulative_density[at_one] = density_above_one

unlinked_r2_cumulative_density = None
unlinked_r2 = numpy.mean(SR2.r2_of_subset['c==0.5'])
count_loci = len(SR2.expected_r2)
scaled_chi2_dist_frozen = chi2(1, scale = unlinked_r2)
scaled_left_cdf = scaled_chi2_dist_frozen.cdf(left_intervals)
scaled_right_cdf = scaled_chi2_dist_frozen.cdf(right_intervals)
scaled_interval_density = scaled_right_cdf - scaled_left_cdf
scaled_interval_density *= count_loci
#print(unlinked_r2, numpy.sum(scaled_interval_density), numpy.max(scaled_interval_density))
if unlinked_r2_cumulative_density is None:
	unlinked_r2_cumulative_density = scaled_interval_density
else:
	unlinked_r2_cumulative_density += scaled_interval_density		
density_above_one = numpy.sum(unlinked_r2_cumulative_density[at_or_above_one])
unlinked_r2_cumulative_density[at_or_above_one] = 0
unlinked_r2_cumulative_density[at_one] = density_above_one

figure(2)
plot((right_intervals + left_intervals)/2., cumulative_density, color = 'red', linewidth= 4.0, alpha = 1, label = "Expected r2")	
plot((right_intervals + left_intervals)/2., mean_r2_cumulative_density, color = 'yellow', linewidth= 4.0, alpha = 1, label = "ChiSq, overall mean r2")	
plot((right_intervals + left_intervals)/2., unlinked_r2_cumulative_density, color = 'purple', linewidth= 4.0, alpha = 1, label = "Unlinked ChiSq ")
hist(SR2.r2_plink, log = True, bins = numpy.arange(0, 1.01, 0.01), alpha = .5, color = 'blue', label = "Simulated Data")
xlim(-.04, 1.04)
ylim(ymin=.1)
ylabel("Count")
xlabel("r2")
legend(loc = "top left")
title("Effective size = 800, 10 chromosomes of 100 loci each")
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

import scipy.stats
sbc = (100/99.)**2
r2_plink = SR.r2_plink
r2_plink_sbc = SR.r2_plink * sbc
r2_plink_sbc[r2_plink_sbc > 1] = 1
expected_r2 = SR.expected_r2


#scipy.stats.gmean(r2_plink_sbc)
#scipy.stats.hmean(r2_plink_sbc)
numpy.mean(scipy.stats.trimboth(numpy.sort(r2_plink_sbc),.1))


SR.estimate_Ne_LDNe(numpy.mean(scipy.stats.trimboth(numpy.sort(r2_plink_sbc),.005)), 100)
SR.estimate_Ne_LDNe(numpy.mean(numpy.sort(r2_plink_sbc)), 100)
	
	
	

# from Results_class import Sim_Results
# sr100a = Sim_Results(r'C:\DATA\simuPOP\batch_16', '100_50_1_2000_2_100_1_1_1')
# sr100b = Sim_Results(r'C:\DATA\simuPOP\batch_16', '100_50_10_2000_2_100_1_1_1')
# sr100c = Sim_Results(r'C:\DATA\simuPOP\batch_16', '100_50_100_2000_2_100_1_1_1')
# sr200a = Sim_Results(r'C:\DATA\simuPOP\batch_16', '200_50_1_2000_2_100_1_1_1')
# sr200b = Sim_Results(r'C:\DATA\simuPOP\batch_16', '200_50_10_2000_2_100_1_1_1')
# sr200c = Sim_Results(r'C:\DATA\simuPOP\batch_16', '200_50_100_2000_2_100_1_1_1')
# sr500a = Sim_Results(r'C:\DATA\simuPOP\batch_16','500_50_1_2000_2_100_1_1_1')
# sr500b = Sim_Results(r'C:\DATA\simuPOP\batch_16','500_50_10_2000_2_100_1_1_1')
# sr500c = Sim_Results(r'C:\DATA\simuPOP\batch_16','500_50_100_2000_2_100_1_1_1')
# sr1000a = Sim_Results(r'C:\DATA\simuPOP\batch_16','1000_50_1_2000_2_100_1_1_1')
# sr1000b = Sim_Results(r'C:\DATA\simuPOP\batch_16','1000_50_10_2000_2_100_1_1_1')
# sr1000c = Sim_Results(r'C:\DATA\simuPOP\batch_16','1000_50_100_2000_2_100_1_1_1')
# sr5000a = Sim_Results(r'C:\DATA\simuPOP\batch_16','800_50_1_2000_2_100_1_1_1')
# sr5000b = Sim_Results(r'C:\DATA\simuPOP\batch_16','800_50_10_2000_2_100_1_1_1')
# sr5000c = Sim_Results(r'C:\DATA\simuPOP\batch_16','800_50_100_2000_2_100_1_1_1')

# import glob
# BASE_DIR = 'C:\\DATA\\simuPOP\\batch_17'
# files = glob.glob(os.path.join(BASE_DIR, '*_1_1_1.gen'))
# count = 0
# for xx in files:
	# count += 1
	# path, full_file_name = os.path.split(xx)
	# file_base, ext = os.path.splitext(full_file_name)
	# #print(path, file_base, ext)
	# SR = Sim_Results(path, file_base)
	# with open(os.path.join("C:/Users/waplesry/Dropbox/Projects/simulate_Ne/sim_analysis/batch_17", 'summary'), 'a') as OUTFILE:
		# if count == 1:
			# to_write = "\t".join(str(jj) for jj in SR.summary().keys())
			# OUTFILE.write(to_write + "\n")
		# to_write = "\t".join(str(jj) for jj in SR.summary().values())
		# OUTFILE.write(to_write + "\n")
# print(sr1000b.r2_of_subset.items())



# sr100a = Sim_Results(r'C:\DATA\simuPOP\batch_12', '100_50_16_5010_30_100_1_1_1')
# sr100b = Sim_Results(r'C:\DATA\simuPOP\batch_12', '100_50_18_5010_30_100_1_1_1')
# sr100c = Sim_Results(r'C:\DATA\simuPOP\batch_12', '100_50_19_5010_30_100_1_1_1')
# sr400a = Sim_Results(r'C:\DATA\simuPOP\batch_12', '400_50_46_5010_30_100_1_1_1')
# sr400b = Sim_Results(r'C:\DATA\simuPOP\batch_12', '400_50_52_5010_30_100_1_1_1')
# sr400c = Sim_Results(r'C:\DATA\simuPOP\batch_12', '400_50_57_5010_30_100_1_1_1')
# sr800a = Sim_Results(r'C:\DATA\simuPOP\batch_12','800_50_72_5010_30_100_1_1_1')
# sr800b = Sim_Results(r'C:\DATA\simuPOP\batch_12','800_50_81_5010_30_100_1_1_1')
# sr800c = Sim_Results(r'C:\DATA\simuPOP\batch_12','800_50_89_5010_30_100_1_1_1')
# sr1600a = Sim_Results(r'C:\DATA\simuPOP\batch_12','1600_50_108_5010_30_100_1_1_1') 
# sr1600b = Sim_Results(r'C:\DATA\simuPOP\batch_12','1600_50_120_5010_30_100_1_1_1') 
# sr1600c = Sim_Results(r'C:\DATA\simuPOP\batch_12','1600_50_132_5010_30_100_1_1_1') 
# sr3200a = Sim_Results(r'C:\DATA\simuPOP\batch_12','3200_50_168_5010_30_100_1_1_1')
# sr3200b = Sim_Results(r'C:\DATA\simuPOP\batch_12','3200_50_187_5010_30_100_1_1_1')
# sr3200c = Sim_Results(r'C:\DATA\simuPOP\batch_12','3200_50_205_5010_30_100_1_1_1')
# sr6400a = Sim_Results(r'C:\DATA\simuPOP\batch_12','6400_50_306_5010_30_100_1_1_1')
# sr6400b = Sim_Results(r'C:\DATA\simuPOP\batch_12','6400_50_341_5010_30_100_1_1_1')
# sr6400c = Sim_Results(r'C:\DATA\simuPOP\batch_12','6400_50_375_5010_30_100_1_1_1')
# # Equilibrium Testing
# sr400_50 = Sim_Results(r'C:\DATA\simuPOP\batch_14','400_50_50_2000_2_100_1_1_1')
# sr400_51 = Sim_Results(r'C:\DATA\simuPOP\batch_14','400_50_51_2000_2_100_1_1_1')
# sr400_52 = Sim_Results(r'C:\DATA\simuPOP\batch_14','400_50_52_2000_2_100_1_1_1')
# sr400_53 = Sim_Results(r'C:\DATA\simuPOP\batch_14','400_50_53_2000_2_100_1_1_1')
# sr400_54 = Sim_Results(r'C:\DATA\simuPOP\batch_14','400_50_54_2000_2_100_1_1_1')

# print(sr400_50.r2_of_subset.items())
# print(sr400_51.r2_of_subset.items())
# print(sr400_52.r2_of_subset.items())
# print(sr400_53.r2_of_subset.items())
# print(sr400_54.r2_of_subset.items())

# import glob
# BASE_DIR = 'C:\\DATA\\simuPOP\\batch_14'
# files = glob.glob(os.path.join(BASE_DIR, '*.gen'))
# count = 0
# for xx in files:
	# count += 1
	# path, full_file_name = os.path.split(xx)
	# file_base, ext = os.path.splitext(full_file_name)
	# #print(path, file_base, ext)
	# SR = Sim_Results(path, file_base)
	# with open(os.path.join("C:/Users/waplesry/Dropbox/Projects/simulate_Ne/sim_analysis/batch_14", 'eq_testing.txt'), 'a') as OUTFILE:
		# if count == 1:
			# to_write = "\t".join(str(jj) for jj in SR.summary().keys())
			# OUTFILE.write(to_write + "\n")
		# to_write = "\t".join(str(jj) for jj in SR.summary().values())
		# OUTFILE.write(to_write + "\n")
# ## ABOVE NOT IN EQUILIBRIUM


New Procedure:

	Pick a set of simulation parameters
		popsize, loci_num, chr_num, chr_cM, cM_unit, [generations_forward]  (mutation_rate*,  sample_size*) 
	for each replicate:
	Generate a Genome Class
		outputs -> SIMCOAL input, simuPOP lociPos, complete_c_matrix
	Create a simuPOP population here, to be later initialized with genotypes
	
	Run SIMCOAL2 -> arlequin format 
	PGD_spider, arlequin to genepop
	
	Import genotypes into simuPOP - should be full pop, no?
	Pass Genome Class into simuPOP
	Forward simulation some generations, proceed as before
		Sampling at certian size at certain generations.
	
	How to do replication?
	
	# 
	
		
		
		
# import glob
# BASE_DIR = "C:\\Users\\waplesry\\Dropbox\\Projects\\simulate_Ne\\sim_data\simcoal2\\sim_unlinked"
# SPID = "C:\\Users\\waplesry\\Dropbox\\Programs\\PGDSpider_2.0.4.0\\arlequin_to_genepop.spid"
# PDG_SPIDER_EXE = "C:\\Users\\waplesry\\Dropbox\\Programs\\PGDSpider_2.0.4.0\\PGDSpider2-cli.exe"
# import PGD_spider
# PGD_spider.batch_pdg_arlequin_to_genepop(spid = SPID,
					# target_dir = BASE_DIR, 
					# output_dir = BASE_DIR, 
					# target_ext = ".arp",
					# pgd_exe = PDG_SPIDER_EXE)
	
# prinr(glob.glob(BASE_DIR+"/*.arp"))



		
# sr100a = Sim_Results(r'C:\DATA\simuPOP\batch_12', '100_50_16_5010_30_100_1_1_1')
# c = sr100a.c_mat
# c_sq = scipy.spatial.distance.squareform(c)		
# ex_r2 = expected_r2_WH(c_sq, 1000)
# r = numpy.sqrt(ex_r2)

# numpy.savetxt(X = r, fname = "r_mat.tsv", delimiter = "\t", fmt = '%1.6f')
		
		
		
		
		
		
		
		


# x = numpy.arange(0.005, .21, .005)
# y = expected_r2_Park(c = x, Ne = 500)
# plot(x, y, color = 'red')
# y = expected_r2_WH(c = x, Ne = 500, reshape = False)
# plot(x, y, color = 'green')
# y = expected_r2_SF(c = x, Ne = 500, reshape = False)
# plot(x, y, color = 'blue')
# matplotlib.pylab.title("Red = Park , Green = Weir & Hill, Blue = Sved & Feldman" )
# pylab.xlabel('c')
# pylab.ylabel('r^2')
# semilogy()
# semilogx()

# n = range(1000)
# y = list()
# for xx in n:
	# y.append(advance_r2_n_generations(500, c =.01, n = xx))
# x = numpy.arange(0.005, .505, .005)
# plot(n, y, color = 'purple')


# cd C:\Users\waplesry\Dropbox\Projects\simulate_Ne\scripts\python
# import Results_class
# my_res_1 = Results_class.Sim_Results(directory = "C:/DATA/simuPOP/batch_11", name = "6400_50_1600_5010_30_100_1_1_1")
# my_res_2 = Results_class.Sim_Results(directory = "C:/DATA/simuPOP/batch_11", name = "1600_50_200_5010_30_100_1_1_1")
# my_res_3 = Results_class.Sim_Results(directory = "C:/DATA/simuPOP/batch_11", name = "1600_50_1600_5010_30_100_1_1_1")

# import glob
# import os.path

# %run -i "C:\Users\waplesry\Dropbox\Projects\simulate_Ne\scripts\python\Sim_Results_class.py"

# sr1 = Sim_Results(r'C:\DATA\simuPOP\batch_10', r'1600_50_1600_5010_30_100_1_1_1')
# sr2 = Sim_Results(r'C:\DATA\simuPOP\batch_10', r'1600_50_512_5010_30_100_1_1_1')




			
# matplotlib.pyplot.hist(sr_KKOKT.r2_plink, log = True, bins = 40, range = (0,1))			
# pylab.xlim([-0, 1])
# numpy.mean(sr_KKOKT.r2_plink)
# pylab.xlabel('Observed R2')
# pylab.ylabel("Count")
# pylab.title("Mean R2: " + str(numpy.mean(sr_KKOKT.r2_plink)))
						

			
			
			
			
# one = Sim_Results(directory = r'C:\DATA\simuPOP\batch_10',
# base_name = '800_200_256_2000_8_100_1_0_4')


# my_run._run_simuPOP(my_run.params[0], BASE_DIR, None)
# my_pop = simuPOP.Population(
							# size = 100, # number of individuals
							# ploidy = 2, 
							# loci = [50] * 2, # number of loci per chromosome * number of chromosomes
							# alleleNames = ('A','T'),
							# )
# PARAM = {
	# 'samp_sizes' : [55],
	# 'cM_unit' : 1000,
	# 'cM_distances': [1000] * 99,
	# 'intermediate_exp_r2': False,
	# 'genepop_out' : True,
	# 'map_ped_out' : True,
	# 'path' : 'C:\\DATA\\simuPOP\\batch_10',
	# 'popsize': 100,
	# 'generation': 20,
	# 'loci_num': 100,
	# 'chr_num': 1,
	# 'chr_cM' : 10,
	# 'scale_recombination' : 1,
	# 'scale_mutation' : 1,
	# 'rep' : 1
# }

	
# my_pop = simuPOP.Population(
							# size = 100, # number of individuals
							# ploidy = 2, 
							# loci = [50] * 2, # number of loci per chromosome * number of chromosomes
							# alleleNames = ('A','T'),
							# )
							
# my_pop.evolve(
			# initOps = [
			  # simuPOP.InitSex(),
			  # simuPOP.InitGenotype(haplotypes = [[0], [1]],	prop = [0.50, 0.50])],
			# matingScheme = simuPOP.RandomMating(),
			# preOps = [
				# simuPOP.SNPMutator(u = .0001, v = .0001)
				# ],
			# postOps = [
				# simuPOP.PyOperator(func = print_gen)
				# ]
				# ,
			# gen = 50
# )

	
	
# mychrom = generate_cM_chromosome(100, 500)
# my_c = c_matrix(mychrom)
# my_c = scipy.spatial.distance.squareform(my_c)
# my_r2 = projected_r2(c= my_c, Ne=  500, S = 50)
# scipy.spatial.distance.squareform(my_r2)



# gen_c, gen_cM = generate_genome_simuPOP(num_chrs = 4, cM = 50, num_loci = 50)
# gen_c_matrix = genome_c_matrix(gen_cM)
# est_r2 = projected_r2(c = gen_c_matrix, Ne=  500, S = 50)

# sr1 = Sim_Results(r'C:\DATA\simuPOP\batch_5', r'simupop_200_16_500_500_1000_4_50_1_1')
# sr2 = Sim_Results(r'C:\DATA\simuPOP\batch_5', r'simupop_200_16_500_500_8000_4_50_1_1')
# sr3 = Sim_Results(r'C:\DATA\simuPOP\batch_5', r'simupop_200_16_16000_500_1000_4_50_1_1')
# sr4 = Sim_Results(r'C:\DATA\simuPOP\batch_5', r'simupop_200_16_16000_500_8000_4_50_1_1')


# sr5 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_500_500_2000_4_0_1_1')
# sr6 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_500_500_2000_4_50_1_1')
# sr7 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_500_2000_2000_4_0_1_1')
# sr8 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_500_2000_2000_4_50_1_1')
# sr9 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_2000_500_2000_4_0_1_1')
# sr10 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_2000_500_2000_4_50_1_1')
# sr11 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_2000_2000_2000_4_0_1_1')
# sr12 = Sim_Results(r'C:\DATA\simuPOP\batch_7', r'simupop_200_17_2000_2000_2000_4_50_1_1')

# sr13 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_30_17_500_1000_1000_4_0_1_1')
# sr14 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_30_17_500_1000_1000_4_50_1_1')
# sr15 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_30_17_2000_1000_1000_4_0_1_1')
# sr16 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_30_17_2000_1000_1000_4_50_1_1')
# sr17 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_200_17_500_1000_1000_4_0_1_1')
# sr18 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_200_17_500_1000_1000_4_50_1_1')
# sr19 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_200_17_2000_1000_1000_4_0_1_1')
# sr20 = Sim_Results(r'C:\DATA\simuPOP\batch_8', r'simupop_200_17_2000_1000_1000_4_50_1_1')


# hexbin(sr1.r2_WH, sr1.r2_SF,mincnt = 1, bins = 'log', gridsize = 60)
						
# #r1 = read_R2_matrix(r"C:\DATA\simuPOP\batch_5\plink\simupop_200_16_1000_500_2000_4_50_1_1.plinkR2")						
# #r2 = read_R2_matrix(r"C:\DATA\simuPOP\batch_5\simupop_200_16_1000_500_2000_4_50_1_1.r2mat_SF.gz")
# #r3 = read_R2_matrix(r"C:\DATA\simuPOP\batch_5\simupop_200_16_1000_500_2000_4_50_1_1.r2mat_WH.gz")
# #r4 = read_R2_matrix(r"C:\DATA\simuPOP\batch_5\simupop_200_16_1000_500_2000_4_50_1_1.cmat.gz")

# #r5 = numpy.empty(r2.shape)
# #r5[r2 < r3] = r2[r2 < r3]
# #r5[r3 <= r2] = r3[r3 <= r2]

# hexbin(r4, 
	# r1,
	# mincnt = 1, bins = 'log', gridsize = 60)
# pylab.ylim([-0.04, 1.04])
# pylab.xlim([-0.02, 0.52])
# cb = matplotlib.pyplot.colorbar()
# pylab.title("c vs Observed R2")
# matplotlib.pyplot.show()

# # Observed R2 vs Recombination Fraction
# hexbin(sr.cmat, 
	# sr.r2_plink,
	# mincnt = 1, bins = 'log', xscale = 'log', gridsize = 60)
# pylab.ylim([-0.04, 1.04])
# pylab.xlim([-0.02, 0.52])
# pylab.title("c vs Observed R2")
# pylab.xlabel('Recombination Fraction (c)')
# pylab.ylabel('Observed R2')
# cb = matplotlib.pyplot.colorbar()
# cb.set_label('log(count)')
# matplotlib.pyplot.show()

# # Observed vs Expected R2
# hexbin(sr.lower_r2_estimate, 
	# sr.r2_plink,
	# mincnt = 1, bins = 'log', gridsize = 30)
# pylab.ylim([-0.04, 1.04])
# pylab.xlim([-0.04, 1.04])
# pylab.title("min exp R2 vs OBS R2")
# pylab.xlabel('Lower of [SF, WH] R2 estimate')
# pylab.ylabel('Observed R2')
# cb = matplotlib.pyplot.colorbar()
# cb.set_label('log(count)')
# matplotlib.pyplot.show()

# hist(r1.flatten(), log = True, bins = 50, alpha = .5)
# hist(r5.flatten(), log = True, bins = 50, alpha =.5)
# pylab.xlim(0, 1)
# cb = matplotlib.pyplot.colorbar()
# hex(r5, r1)
