def plot_r2_distribution(self, subset_key = None):
	obs_r2 = self.r2_plink
	exp_r2 = self.lower_r2_estimate
	if subset_key is None:
		pass
	else:
		obs_r2 = obs_r2[subset_loci[subset_key]]
		exp_r2 = exp_r2[subset_loci[subset_key]]
	
	matplotlib.pyplot.hist(obs_r2, log = True, bins = 50, range = (0,1), alpha = .5)
	matplotlib.pyplot.hist(exp_r2, log = True, bins = 50, range = (0,1), alpha =.5)
	pylab.xlim(0, 1)
	pylab.title("Blue = Observed, Green = Expected\n{}, Subset = {}".format(self.name, subset_key))
	pylab.ylabel("Count")
	pylab.xlabel("R2")
	
# Observed vs Expected R2
def plot_obs_exp_r2(self, subset_key = None):
	obs_r2 = self.r2_plink
	exp_r2 = self.lower_r2_estimate
	if subset_key is None:
		pass
	else:
		obs_r2 = obs_r2[subset_loci[subset_key]]
		exp_r2 = exp_r2[subset_loci[subset_key]]
		
	matplotlib.pyplot.hexbin(exp_r2, obs_r2,
		mincnt = 1, bins = 'log', gridsize = 30)
	pylab.ylim([-0.04, 1.04])
	pylab.xlim([-0.04, 1.04])
	pylab.title("exp R2 vs OBS R2\n{}, Subset = {}".format(self.name, subset_key))
	pylab.xlabel('Lower of [SF, WH] expected R2 ')
	pylab.ylabel('Observed R2')
	cb = matplotlib.pyplot.colorbar()
	cb.set_label('log(count)')
	matplotlib.pyplot.show()

# Observed R2 vs Recombination Fraction
def plot_c_obs_r2(self, subset_key = None):
	c_mat = self.c_mat
	obs_r2 = self.r2_plink
	if subset_key is None:
		pass
	else:
		c_mat = c_mat[subset_loci[subset_key]]
		obs_r2 = obs_r2[subset_loci[subset_key]]
	
	matplotlib.pyplot.hexbin(c_mat, obs_r2,
		mincnt = 1, bins = 'log', gridsize = 60,
		#xscale = 'log'
		 )
	pylab.ylim([-0.04, 1.04])
	pylab.xlim([-0.02, 0.52])
	pylab.title("c vs Observed R2\n{}, Subset = {}".format(self.name, subset_key))
	pylab.xlabel('Recombination Fraction (c)')
	pylab.ylabel('Observed R2')
	cb = matplotlib.pyplot.colorbar()
	cb.set_label('log(count)')
	matplotlib.pyplot.show()
	
def plot_r2_hist(self, subset_key = None):
	obs_r2 = self.r2_plink
	if subset_key is None:
		pass
	else:
		obs_r2 = obs_r2[subset_loci[subset_key]]
	matplotlib.pyplot.hist(obs_r2, log = True