import glob
import os.path
import matplotlib.pyplot

from Results_class_WORKING import Sim_Results
from PARAMS import BASE_DIR, DEBUG

def write_Sim_Report(report_dir, target_dir):
	if not os.path.exists(report_dir):
		os.mkdir(report_dir)
	files = glob.glob(os.path.join(target_dir, 'samples', 'genepop', '*.gen'))
	print("Found {} simulations to report on".format(len(files)))
	count = 0
	for file_name in files:
		count += 1
		path, full_file_name = os.path.split(file_name)
		file_base, ext = os.path.splitext(full_file_name)
		SR = Sim_Results(BASE_DIR, file_base)
		with open(os.path.join(report_dir, 'summary.tsv'), 'a') as OUTFILE:
			if count == 1: # on first file, start by writing a header
				to_write = "\t".join(str(jj) for jj in SR.summary().keys())
				OUTFILE.write(to_write + "\n")
			to_write = "\t".join(str(jj) for jj in SR.summary().values())
			OUTFILE.write(to_write + "\n")
			if DEBUG:
				print("Summary of {}: completed, written to: {} ".format(file_base, os.path.join(report_dir, 'summary.tsv')))
				
def write_Sim_obs_exp_r2_plots(report_dir, target_dir = BASE_DIR, subset_key = None):
	if not os.path.exists(report_dir):
		os.mkdir(report_dir)
	files = glob.glob(os.path.join(target_dir, '*.gen'))
	count = 0
	if DEBUG: print("found {} files".format(len(files)))
	for file_name in files:
		count += 1
		path, full_file_name = os.path.split(file_name)
		file_base, ext = os.path.splitext(full_file_name)
		SR = Sim_Results(path, file_base)
		matplotlib.pyplot.figure()
		SR.plot_obs_exp_r2(subset_key = subset_key)
		matplotlib.pyplot.savefig(os.path.join(report_dir, file_base + ".pdf" ))
		
def write_r2_distribution_plots(report_dir, target_dir = BASE_DIR, subset_key = None):
	if not os.path.exists(report_dir):
		os.mkdir(report_dir)
	files = glob.glob(os.path.join(target_dir, '*.gen'))
	count = 0
	if DEBUG: print("found {} files".format(len(files)))
	for file_name in files:
		count += 1
		path, full_file_name = os.path.split(file_name)
		file_base, ext = os.path.splitext(full_file_name)
		SR = Sim_Results(path, file_base)
		matplotlib.pyplot.figure()
		SR.plot_r2_distribution(subset_key = subset_key)
		matplotlib.pyplot.savefig(os.path.join(report_dir, file_base + ".pdf" ))
		
