# Plotting Genomes
from Genome_class import Genome
#from matplotlib.backends.backend_pdf import PdfPages
import scipy

fivehundred_chr_10_loci = Genome(chr_num = 500, chr_cM = 100, chr_loci = 10, cM_unit = 100, map_function = "kosambi")
fifty_chr_100_loci = Genome(chr_num = 50, chr_cM = 100, chr_loci = 100, cM_unit = 100, map_function = "kosambi")
ten_chr_500_loci = Genome(chr_num = 10, chr_cM = 100, chr_loci = 500, cM_unit = 100, map_function = "kosambi")

#pp = PdfPages("C:\Users\waplesry\Dropbox\Projects\simulate_Ne\plots\Genome_figures_batch_3.pdf")
figure(1)
points_10 = hist(numpy.diff(fivehundred_chr_10_loci.cM_genome).flatten(), bins = numpy.arange(0,25, .5), color = 'red', alpha = .6, label = "10 loci per Chromosome")
points_100 =hist(numpy.diff(fifty_chr_100_loci.cM_genome).flatten(), bins = numpy.arange(0,25, .5), color = 'blue', alpha = .6, label = "100 loci per Chromosome")
points_500 =hist(numpy.diff(ten_chr_500_loci.cM_genome).flatten(), bins = numpy.arange(0,25, .5), color = 'green', alpha = .6, label = "500 loci per Chromosome")
xlabel("centiMorgans")
ylabel("Count")
title("Distance between loci in cM")
legend()
savefig("C:/Users/waplesry/Dropbox/Projects/simulate_Ne/plots/fig_1.pdf" )

one_chromosome_10_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 10, cM_unit = 100, map_function = "kosambi")
one_chromosome_50_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 50, cM_unit = 100, map_function = "kosambi")
one_chromosome_100_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 100, cM_unit = 100, map_function = "kosambi")
one_chromosome_500_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 500, cM_unit = 100, map_function = "kosambi")
reps = 1000
lines_1_y = 0
lines_2_y = 0
lines_3_y = 0
lines_4_y = 0

for xx in range(reps):
    one_chromosome_10_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 10, cM_unit = 100, map_function = "kosambi")
    one_chromosome_50_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 50, cM_unit = 100, map_function = "kosambi")
    one_chromosome_100_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 100, cM_unit = 100, map_function = "kosambi")
    one_chromosome_500_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 500, cM_unit = 100, map_function = "kosambi")
    lines_1_rep = hist(scipy.spatial.distance.squareform(one_chromosome_10_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02), visible = False)
    lines_2_rep = hist(scipy.spatial.distance.squareform(one_chromosome_50_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02), visible = False)
    lines_3_rep = hist(scipy.spatial.distance.squareform(one_chromosome_100_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02), visible = False)
    lines_4_rep = hist(scipy.spatial.distance.squareform(one_chromosome_500_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02), visible = False)
    lines_1_y += lines_1_rep[0]
    lines_2_y += lines_2_rep[0]
    lines_3_y += lines_3_rep[0]
    lines_4_y += lines_4_rep[0]  
lines_1 = hist(scipy.spatial.distance.squareform(one_chromosome_10_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02))
lines_2 = hist(scipy.spatial.distance.squareform(one_chromosome_50_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02))
lines_3 = hist(scipy.spatial.distance.squareform(one_chromosome_100_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02))
lines_4 = hist(scipy.spatial.distance.squareform(one_chromosome_500_loci.c_matrix), log = True, bins = numpy.arange(0, .52, .02))


# Which Figure 2???
figure(2)
plot(lines_1[1][1:], lines_1_y/numpy.float(numpy.sum(lines_1_y)), '-', color = 'red', lw  = 3, alpha = .4, label = "10 Loci Per Chromosome")
plot(lines_2[1][1:], lines_2_y/numpy.float(numpy.sum(lines_2_y)), '-', color = 'purple', lw  = 3, alpha = .4, label = "50 Loci Per Chromosome")
plot(lines_3[1][1:], lines_3_y/numpy.float(numpy.sum(lines_3_y)), '-', color = 'green', lw  = 3, alpha = .4, label = "100 Loci Per Chromosome")
plot(lines_4[1][1:], lines_4_y/numpy.float(numpy.sum(lines_4_y)), '-', color = 'purple', lw  = 3, alpha = .4, label = "500 Loci Per Chromosome")
legend(position = "lower left")

figure(2)
plot(lines_1[1][1:], lines_1[0], '-', color = 'red', lw  = 3, alpha = .7)
plot(lines_2[1][1:], lines_2[0], '-', color = 'blue', lw  = 3, alpha = .7)
plot(lines_3[1][1:], lines_3[0], '-', color = 'green', lw  = 3, alpha = .7)
plot(lines_4[1][1:], lines_4[0], '-', color = 'purple', lw  = 3, alpha = .7)
title("Red = 10 loci, Blue = 50\nGreen = 100, Purple = 500")
ylabel('Count')
xlabel('Recombination Fraction')
semilogy()




one_chromosome_200_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")
five_chromosome_200_loci = Genome(chr_num = 5, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")
ten_chromosome_200_loci = Genome(chr_num = 10, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")
twenty_chromosome_200_loci = Genome(chr_num = 20, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")
to_plot_1 = hist(one_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))
to_plot_2 = hist(five_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))
to_plot_3 = hist(ten_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))
to_plot_4 = hist(twenty_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))

figure(3)
plot(to_plot_1[1][1:], to_plot_1[0], '-', color = 'red', lw  = 3, alpha = .5, label = "One Chromosome")
plot(to_plot_2[1][1:], to_plot_2[0], '-', color = 'green', lw  = 3, alpha = .5, label = "Five Chromosomes")
plot(to_plot_3[1][1:], to_plot_3[0], '-', color = 'blue', lw  = 3, alpha = .5, label = "Ten Chromosomes")
plot(to_plot_4[1][1:], to_plot_4[0], '-', color = 'purple', lw  = 3, alpha = .5, label = "Twenty Chromosomes")
title("200 Loci per chromosome")
ylabel('Count')
xlabel('Recombination Fraction')
ylim(1, 100000000)
semilogy()
legend(loc = 'upper left')
savefig(savefig("C:/Users/waplesry/Dropbox/Projects/simulate_Ne/plots/fig_3.pdf" ))

figure(4)
plot(to_plot_1[1][1:], to_plot_1[0]/numpy.float(numpy.sum(to_plot_1[0])), '-', color = 'red', lw  = 3, alpha = .5, label = "One Chromosome")
plot(to_plot_2[1][1:], to_plot_2[0]/numpy.float(numpy.sum(to_plot_2[0])), '-', color = 'green', lw  = 3, alpha = .5, label = "Five Chromosomes")
plot(to_plot_3[1][1:], to_plot_3[0]/numpy.float(numpy.sum(to_plot_3[0])), '-', color = 'blue', lw  = 3, alpha = .5, label = "Ten Chromosomes")
plot(to_plot_4[1][1:], to_plot_4[0]/numpy.float(numpy.sum(to_plot_4[0])), '-', color = 'purple', lw  = 3, alpha = .5, label = "Twenty Chromosomes")
title("200 Loci per chromosome")
ylabel('Percent Makeup')
xlabel('Recombination Fraction')
ylim(.001, 1.5)
semilogy()
legend(loc = 'upper left')
savefig(savefig("C:/Users/waplesry/Dropbox/Projects/simulate_Ne/plots/fig_3.pdf" ))




figure(0)
points_10 = hist(numpy.diff(fivehundred_chr_10_loci.cM_genome).flatten(), bins = range(0,25))
plot(points[1][1:], points[0])
title('Adjacent cM distance\n10 Loci')
ylabel('Count')
xlabel('cM')
xlim(0, 25)
pp.savefig(0)
figure(1)
points_100 =hist(numpy.diff(fifty_chr_100_loci.cM_genome).flatten(), bins = 20)
title('Adjacent cM distance\n100 Loci')
ylabel('Count')
xlabel('cM')
xlim(0, 5)
pp.savefig(1)
figure(2)
points_500 =hist(numpy.diff(ten_chr_500_loci.cM_genome).flatten(), bins = 20)
title('Adjacent cM distance\n500 Loci')
ylabel('Count')
xlabel('cM')
xlim(0, 5)
pp.savefig(2)

one_chromosome_200_loci = Genome(chr_num = 1, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")
five_chromosome_200_loci = Genome(chr_num = 5, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")
ten_chromosome_200_loci = Genome(chr_num = 10, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")
twenty_chromosome_200_loci = Genome(chr_num = 20, chr_cM = 100, chr_loci = 200, cM_unit = 100, map_function = "kosambi")

figure(3)
hist(one_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))
ylim(1, 100000000)
title('All pairs of loci\nOne chromosome of 200 loci ')
ylabel('Count')
xlabel('Recombination Fraction')
#xscale('log')
pp.savefig(3)
figure(4)
hist(five_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))
ylim(1, 100000000)
title('All pairs of loci\nFive chromosomes of 200 loci ')
ylabel('Count')
xlabel('Recombination Fraction')
#xscale('log')
pp.savefig(4)
figure(5)
hist(ten_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))
ylim(1, 100000000)
title('All pairs of loci\nTen chromosomes of 200 loci ')
ylabel('Count')
xlabel('Recombination Fraction')
#xscale('log')
pp.savefig(5)
figure(6)
hist(twenty_chromosome_200_loci.c_matrix.flatten(), log = True, bins = numpy.arange(0, .52, .02))
ylim(1, 100000000)
title('All pairs of loci\nTwenty chromosomes of 200 loci ')
ylabel('Count')
xlabel('Recombination Fraction')
#xscale('log')
pp.savefig(6)



def d_equals_r(r):
    d = r
    return(d)
    
def haldane_mf(r):
    d = -.5 * log(1- (2 * r))
    return(d)
    
def kosambi_mf(r):
    d = .25 * log((1+(2*r))/(1-(2*r)))
    return(d)
c = numpy.arange(0, .50, .01)
#plot(c, kosambi_mf(c), color = 'red')
#plot(c, haldane_mf(c), color = 'blue')
#plot(c, d_equals_r(c), color = 'green')
figure(7)
plot( kosambi_mf(c),c, color = 'red', label = 'Kosambi', lw = 3)
plot( haldane_mf(c), c, color = 'blue', label = 'Haldane', lw = 3)
plot( d_equals_r(c),c, color = 'green', label = 'cM = c', lw = 3)
xlabel('Morgans')
ylabel('Recombination Fraction (c)')
legend(loc='bottom right')
savefig("C:/Users/waplesry/Dropbox/Projects/simulate_Ne/plots/Mapping_functions.pdf" )






#### OLD

#figure(1)
#plot(points_500[1][1:], points_500[0], '-', color = 'red', lw  = 3, alpha = .7)
#plot(points_10[1][1:], points_10[0], '-', color = 'blue', lw  = 3, alpha = .7)
#plot(points_100[1][1:], points_100[0], '-', color = 'green', lw  = 3, alpha = .7)
##yscale('log')
#ylabel('Count')
#xlabel('cM')
#title("Red = 10 loci per chr\nBlue = 100 loci, Green = 500 loci")
#pp.savefig(1)

#figure(2)
#plot(points_500[1][1:], points_500[0], '-', color = 'red', lw  = 3, alpha = .7)
#plot(points_10[1][1:], points_10[0], '-', color = 'blue', lw  = 3, alpha = .7)
#plot(points_100[1][1:], points_100[0], '-', color = 'green', lw  = 3, alpha = .7)
#yscale('log')
#ylabel('Count')
#xlabel('cM')
#title("Red = 10 loci per chr\nBlue = 100 loci, Green = 500 loci")
#pp.savefig(2)


#figure(3)
#plot(lines_1[1][1:], lines_1[0], '-', color = 'red', lw  = 3, alpha = .7)
#plot(lines_2[1][1:], lines_2[0], '-', color = 'green', lw  = 3, alpha = .7)
#plot(lines_3[1][1:], lines_3[0], '-', color = 'blue', lw  = 3, alpha = .7)
#plot(lines_4[1][1:], lines_4[0], '-', color = 'purple', lw  = 3, alpha = .7)
#title("Red = 10 loci, Green = 50\nBlue = 100, Purple = 500")
#ylabel('Count')
#xlabel('Recombination Fraction')
#pp.savefig(3)